#!/bin/dash
#
# unbind-yubikey.sh
# this is an helper script to unbind yubikey from usbhid
# it should always work 
#    Michael Bonfils

DIR=/sys/bus/usb/drivers/usbhid
VENDOR=1050
PRODUCT=0010

vendor_product() {
	cd $1
	if [ $? -ne 0 ]; then
		echo ffff ffff
		return 1
	fi
	cd $2

	while true; do
		if [ -f idVendor ] && [ -f idProduct ]; then
			echo `cat idVendor` `cat idProduct`
			return 0
		fi
		cd ..
		if [ $? -ne 0 ]; then
			echo ffff ffff
			return 1
		fi
	done
	return 1
}

for i in `find $DIR -type l`; do
	ITEM="`basename $i`"
	if [ "$ITEM" = "module" ]; then 
		continue
	fi


	echo "parsing $ITEM"
	CUR=$( vendor_product $DIR `readlink $i` )
	if [ "$CUR" = "$VENDOR $PRODUCT" ]; then
		echo "Found YubiKey, unbind it"
		echo $ITEM > $DIR/unbind
		echo "To bind again, please unplug and replug it"
	fi
done
